diff --git a/Makefile b/Makefile
index d835bb92e7..5ffb7ed57f 100644
--- a/Makefile
+++ b/Makefile
@@ -649,7 +649,8 @@ s390-ccw.img s390-netboot.img \
 spapr-rtas.bin slof.bin skiboot.lid \
 palcode-clipper \
 u-boot.e500 \
-qemu_vga.ndrv
+qemu_vga.ndrv \
+hppa-firmware.img
 else
 BLOBS=
 endif
diff --git a/.gitmodules b/.gitmodules
index 1500579638..7a8282df46 100644
--- a/.gitmodules
+++ b/.gitmodules
@@ -40,3 +40,6 @@
 [submodule "capstone"]
 	path = capstone
 	url = git://git.qemu.org/capstone.git
+[submodule "roms/seabios-hppa"]
+	path = roms/seabios-hppa
+	url = git://github.com/hdeller/seabios-hppa.git
diff --git a/pc-bios/hppa-firmware.img b/pc-bios/hppa-firmware.img
new file mode 100755
index 0000000000000000000000000000000000000000..ae833437a73cb0955491b95f03cd42132d8d2e9c
GIT binary patch
diff --git a/roms/seabios-hppa b/roms/seabios-hppa
new file mode 160000
index 0000000000..8fa4ca9935
--- /dev/null
+++ b/roms/seabios-hppa
@@ -0,0 +1 @@
+Subproject commit 8fa4ca9935669414a824ecda24f6e70c36e8dc94